#!/bin/sh
#
# simple vlsserver skript to be started from inetd.
# just takes one argument on stdin: the channel name. 
# There are 2 "magic" names:
#   1. "list" lists all available channels
#   2. "exit" kills running vls and exits.
#
# config section:
VLS="vls"
VLSCFG="/usr/local/etc/vls.cfg"

read STATION

list_stations() {
  echo ""      # how to access (example: "@239.192.0.1")
  echo "no"    # need to stop/start vlc after channel-change?
  awk '/^\[[^(global|defaults)]/ \
           {print substr($0, 2, length($0)-2)}' /root/.xawtv
}

kill_vls() {
  killall $VLS 2>/dev/null

  for i in false false false false false false false false false true; do
    pidof $VLS > /dev/null || break
    usleep 100000
  done
  $i && { killall -9 $VLS; echo "kill -9!"; }
}

case "$STATION" in
  exit) kill_vls
        echo "exit"
        ;;
  list) list_stations
     ;;
  *) echo $STATION
     kill_vls # at least with v4l1 we need to kill vls before tuning.
     /usr/X11R6/bin/v4lctl setstation "$STATION"
     $VLS -f $VLSCFG >> /var/log/vlsserver.log 2>&1 &
     ;;
esac

